# Perforat

**Perforat** monitors your tests and notice in case some of them significant slowed down.

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'perforat'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install perforat

Then you need to require it on your `rails_helper` or `spec_helper`

```ruby
require 'perforat'
```
As each test running takes different time to run there are some settings to tune it:

```ruby
:results_count,    default: 20   # how much notification can be displayed
:minimal_duration, default: 0.1  # in case of your tests are really fast they produce really huge coefficients event without any changes, minimal_duration` uses to minimal false positive activation.
:minimal_epsilon,  default: 0.1  # in case of test takes acceptable time it can be not so slowed down to notify about it
:keep_files,       default: 2    # **Perforat** need only last two files to see difference between tests duration, so if you need more -- you always can change this setting
```

To configure it add you need to pass params to RSpec settings

```ruby
RSpec.configure do |config|
  config.perforat = { keep_files: 5 }
end
```

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/ignat-zakrevsky/perforat.


## License

The gem is available as open source under the terms of the [MIT License](http://opensource.org/licenses/MIT).
